package dev.shadowsoffire.apotheosis.garden;

import net.minecraft.world.level.Level;
import net.minecraftforge.common.ForgeHooks;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.util.RandomSource;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.state.StateDefinition;
import dev.shadowsoffire.placebo.util.IReplacementBlock;
import net.minecraft.world.level.block.SugarCaneBlock;

public class ApothSugarcaneBlock extends SugarCaneBlock implements IReplacementBlock
{
    protected StateDefinition<Block, BlockState> container;
    
    public ApothSugarcaneBlock() {
        super(BlockBehaviour.Properties.m_60926_((BlockBehaviour)Blocks.f_50130_));
    }
    
    public void m_213898_(final BlockState state, final ServerLevel worldIn, final BlockPos pos, final RandomSource random) {
        if (worldIn.m_46859_(pos.m_7494_())) {
            int i = 0;
            if (GardenModule.maxReedHeight <= 32) {
                for (i = 1; worldIn.m_8055_(pos.m_6625_(i)).m_60734_() == this; ++i) {}
            }
            if (i < GardenModule.maxReedHeight) {
                final int j = (int)state.m_61143_((Property)ApothSugarcaneBlock.f_57164_);
                if (ForgeHooks.onCropsGrowPre((Level)worldIn, pos, state, true)) {
                    if (j == 15) {
                        worldIn.m_46597_(pos.m_7494_(), this.m_49966_());
                        worldIn.m_7731_(pos, (BlockState)state.m_61124_((Property)ApothSugarcaneBlock.f_57164_, (Comparable)0), 4);
                    }
                    else {
                        worldIn.m_7731_(pos, (BlockState)state.m_61124_((Property)ApothSugarcaneBlock.f_57164_, (Comparable)(j + 1)), 4);
                    }
                    ForgeHooks.onCropsGrowPost((Level)worldIn, pos, state);
                }
            }
        }
    }
    
    @Deprecated
    public void m_6861_(final BlockState state, final Level world, final BlockPos pos, final Block block, final BlockPos origin, final boolean isMoving) {
        if (pos.m_123342_() != origin.m_123342_()) {
            super.m_6861_(state, world, pos, block, origin, isMoving);
        }
    }
    
    public void _setDefaultState(final BlockState state) {
        this.m_49959_(state);
    }
    
    public void setStateContainer(final StateDefinition<Block, BlockState> container) {
        this.container = container;
    }
    
    public StateDefinition<Block, BlockState> m_49965_() {
        return (StateDefinition<Block, BlockState>)((this.container == null) ? super.m_49965_() : this.container);
    }
}
